CATIA VBA利用选中line/spline进行测量

以下是使用 selectelement3 和 SpaWorkbench 实现的代码片段:


```vba

Dim PD1 As PartDocument

Dim Sel 'as Selection ''Sometimes it is needed to comment the selection to use the .SelectElement3 method'

Dim InputObjType(0)

Dim SelectionResult As String

Dim LineToMeasure As AnyObject

Dim I As Integer

Dim SpaWorkbench As SPAWorkbench

Dim Measurable As Measurable


InputObjType(0) = "AnyObject"


'set PD1 = Catia.ActiveDocument'

Set Sel = PD1.Selection

Set TheSPAWorkbench = PD1.GetWorkbench("SPAWorkbench")


Sel.Clear

SelectionResult = Sel.SelectElement3(InputObject, "Select objects to list names", True, CATMultiSelTriggWhenUserValidatesSelection, False)


If SelectionResult = "Ok" Or SelectionResult = "Normal" Then 'Check if user did not cancel the Selection'

   For I = 1 To Selection.Count

       Set LineToMeasure = Sel.Item(I).Value

       Set Measurable = SpaWorkbench.GetMeasurable(LineToMeasure)


       'Measure whatever you need here.'

   Next

End If

```


以下是使用参数和公式,并配合 Query 和 length 函数的片段:


```vba

Dim totalLength As Double


'如果所测元素全部在一个几何集("cableway_curves" ),可以创建一个totalLength 的参数,并使用如下公式:'

totalLength = length(cableway_curves->Query("Curve",""))


'否则,可以使用如下公式(假设几何集名称为cableway.1, cableway.2 ... ):'

totalLength = length(myPart->Query("Curve","x.Name->Search(\"cableway.\")==0"))


'以下写法可以作为参考: Query("Curve","x->IsSupporting(\"GSMDirection\")==false")" ,避免查重,要求意思一样'

```

希望这样改写符合您的需要。

QR Code
微信扫一扫,欢迎咨询~

联系我们
武汉格发信息技术有限公司
湖北省武汉市经开区科技园西路6号103孵化器
电话:155-2731-8020 座机:027-59821821
邮件:tanzw@gofarlic.com
Copyright © 2023 Gofarsoft Co.,Ltd. 保留所有权利
遇到许可问题?该如何解决!?
评估许可证实际采购量? 
不清楚软件许可证使用数据? 
收到软件厂商律师函!?  
想要少购买点许可证,节省费用? 
收到软件厂商侵权通告!?  
有正版license,但许可证不够用,需要新购? 
联系方式 155-2731-8020
预留信息,一起解决您的问题
* 姓名:
* 手机:

* 公司名称:

姓名不为空

手机不正确

公司不为空